/**
 */
package spectra.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import spectra.Model;
import spectra.SpectraFactory;
import spectra.SpectraPackage;

/**
 * This is the item provider adapter for a {@link spectra.Model} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ModelItemProvider 
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Model_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Model_name_feature", "_UI_Model_type"),
				 SpectraPackage.Literals.MODEL__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(SpectraPackage.Literals.MODEL__IMPORTS);
			childrenFeatures.add(SpectraPackage.Literals.MODEL__ELEMENTS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Model.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Model"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Model)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Model_type") :
			getString("_UI_Model_type") + " " + label;
	}


	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Model.class)) {
			case SpectraPackage.MODEL__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case SpectraPackage.MODEL__IMPORTS:
			case SpectraPackage.MODEL__ELEMENTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__IMPORTS,
				 SpectraFactory.eINSTANCE.createImport()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createDecl()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createWeightDef()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createVar()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createTypeDef()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createDefine()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createDefineRegExp()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createCounter()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createMonitor()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createPattern()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createLTLGar()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createLTLAsm()));

		newChildDescriptors.add
			(createChildParameter
				(SpectraPackage.Literals.MODEL__ELEMENTS,
				 SpectraFactory.eINSTANCE.createEXGar()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return SpectraEditPlugin.INSTANCE;
	}

}
